package com.weaver.seconddev.njwebservice;

import com.alibaba.fastjson.JSON;
import com.weaver.common.hrm.util.Util;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.seconddev.njwebservice.entity.ToDoCountReq;
import com.weaver.seconddev.njwebservice.entity.ToDoRequestReq;
import com.weaver.seconddev.njwebservice.entity.ToDoRequestRes;
import com.weaver.seconddev.njwebservice.entity.ToDoWorkFlow;
import com.weaver.verupgrade.conn.CONN_TYPE;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.workflow.webservices.WorkflowRequestInfo;
import com.weaver.verupgrade.workflow.webservices.WorkflowService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.net.URLEncoder;

/**
 *获取待办数量和待办信息
 */
@Service("outToDoWorkflowService")
public class OutToDoWorkflowService {

    @Autowired
    private WorkflowService workflowService;


    private final static Logger log = LoggerFactory.getLogger(OutToDoWorkflowService.class);


    public String outToDoWorkflowCount(String json) {

        log.error("outToDoWorkflowCount入参:"+json);
        ToDoCountReq param = JSON.parseObject(json, ToDoCountReq.class);
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.hrm.getType();
        String sql = "select ID from eteams.employee where status = 'normal' and job_num = '"+param.getWorkcode()+"'";
        rs.executeSql(sql,poolname);
        if (rs.next()){
            Long userId = Util.getLongValue(rs.getString("id"));
            int toDoWorkflowRequestCount = workflowService.getToDoWorkflowRequestCount(userId, param.getConditions());
            log.error("待办数量："+toDoWorkflowRequestCount);
            return String.valueOf(toDoWorkflowRequestCount);
        }else {
            return "未找到该用户";
        }
    }

    public ToDoRequestRes outToDoWorkflowList(String json) {
//        String pc_url = Util.null2String(this.getPropValue("htportaloaUrl", "pc_url")).trim();
//        String mobile_url = Util.null2String(this.getPropValue("htportaloaUrl", "mobile_url")).trim();

        log.error("outToDoWorkflowCount入参:"+json);
        ToDoRequestReq param = JSON.parseObject(json, ToDoRequestReq.class);
        // todo 访问ip 配置
        String pc_url = "";
        String mobile_url = "";
        ToDoRequestRes res = new ToDoRequestRes();
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.hrm.getType();
        String sql = "select id from eteams.employee where status = 'normal' and job_num = '"+param.getWorkcode()+"'";
        rs.executeSql(sql,poolname);
        if (!rs.next()) {
            res.setMsg("未找到该用户");
        } else {
            param.setWorkcode(Util.null2String(rs.getString("id")));
            Long userId = Util.getLongValue(rs.getString("id"));
            log.error("用户id:"+userId);
            WorkflowRequestInfo[] info = workflowService.getToDoWorkflowRequestList(Integer.parseInt(param.getPageNo()), Integer.parseInt(param.getPageSize()),
                    Integer.parseInt(param.getRecordCount()), userId, param.getConditions());

            res.setMsg("find:" + info.length);
            ToDoWorkFlow[] todo = new ToDoWorkFlow[info.length];

            for(int i = 0; i < info.length; ++i) {
                ToDoWorkFlow wftodo = new ToDoWorkFlow();
                wftodo.createTime = Util.null2String(info[i].getCreateTime());
                wftodo.creatorName = Util.null2String(info[i].getCreatorName());
                wftodo.currentNodeName = Util.null2String(info[i].getCurrentNodeName());
                wftodo.lastOperateTime = Util.null2String(info[i].getLastOperateTime());
                wftodo.lastOperatorName = Util.null2String(info[i].getLastOperatorName());
                wftodo.receiveTime = Util.null2String(info[i].getReceiveTime());
                wftodo.requestId = Util.null2String(info[i].getRequestId());
                wftodo.requestLevel = Util.null2String(info[i].getRequestLevel());
                wftodo.requestName = Util.null2String(info[i].getRequestName());
                wftodo.workflowId = Util.null2String(info[i].getWorkflowBaseInfo().getWorkflowId());
                wftodo.workflowName = Util.null2String(info[i].getWorkflowBaseInfo().getWorkflowName());
                wftodo.workflowTypeId = Util.null2String(info[i].getWorkflowBaseInfo().getWorkflowTypeId());
                wftodo.workflowTypeName = Util.null2String(info[i].getWorkflowBaseInfo().getWorkflowTypeName());
                wftodo.mobileurl = mobile_url + URLEncoder.encode("/spa/workflow/static4mobileform/index.html#/req?requestid=" + wftodo.requestId);
                wftodo.pcurl = pc_url + URLEncoder.encode("/spa/workflow/static4form/index.html#/main/workflow/req?requestid=" + wftodo.requestId);
                todo[i] = wftodo;
            }
            res.setWorkFlow(todo);
        }
        return res;
    }
}
