package com.weaver.seconddev.njwebservice;

import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.seconddev.njwebservice.entity.WlpsSyResponse;
import com.weaver.seconddev.njwebservice.entity.WlpsSyReturn;
import com.weaver.seconddev.njwebservice.util.SecondUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import com.weaver.verupgrade.conn.RecordSet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

/**
 * @Author liang.cheng
 * @Date 2025/1/20 13:54
 * @Description:
 * @Version 1.0
 */

@Service("wlpsSyGetResWebservice")
public class WlpsSyGetResService {

    private final static Logger log = LoggerFactory.getLogger(WlpsSyGetResService.class);

    public void getRes(WlpsSyResponse res) {
        log.error("接收MesWLPS_SY接口返回值开始");
        String isTat = res.getIsTat();
        String systemId = res.getSysId();
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.workflow.getType();
        try{
            if("S".equals(isTat)){
                WlpsSyReturn[] ret = res.getWlpsSyReturn();

                for(int i=0;i<ret.length;i++){
                    String workflowid = ret[i].getWorkflowID();
                    String tablename = SecondUtil.getTableName(workflowid);
                    String requestid = ret[i].getRequestId();
                    String state = ret[i].getIsTat();
                    String message  = ret[i].getMessage();
                    if(!"".equals(workflowid)&&!"".equals(requestid)&&workflowid.equals(SecondUtil.getWorkflowIdByReq(requestid))){
                        String sql = "update "+tablename+" set state='"+state+"',message='"+message+"' where requestId="+requestid;
                        rs.executeSql(sql,poolname);
                        log.error(systemId+"--"+requestid+"更新成功");
                    }else{
                        log.error("MesWLPS_SY返回数据不符合要求"+res);
                    }
                }
            }
            log.error("接收MesWLPS_SY接口返回值结束");
        }catch(Exception e){
            log.error("接收MesWLPS_SY接口返回值出错："+e.toString());
        }
    }

}
